package hos;

public class Homerseklet {
	public enum MertekEgyseg { CELSIUS, KELVIN };
	private double hoertek;			// kelvinben letrolva
	
	public Homerseklet(double ho, MertekEgyseg egyseg) {
		if (egyseg == MertekEgyseg.KELVIN) 
			this.hoertek = ho;
		else 
			this.hoertek = celsiusToKelvin(ho);  /* valami nem jo */
	}
	
	
	public Homerseklet(double ho) {
		this(ho, MertekEgyseg.KELVIN);
	}
	

	private double celsiusToKelvin(double ho) {
		return ho + 273.1;
	}

	
	private double kelvinToCelsius(double ho) {
		return ho - 273.1;
	}
	
	
	public String toString() {
		return this.hoertek + "Kelvin";
	}
	
	
	public double getHo(MertekEgyseg egyseg) {
		if(egyseg == MertekEgyseg.KELVIN)
			return this.hoertek;
		else
			return kelvinToCelsius(this.hoertek);		
	}
	

	public boolean nagyobbEMint(Homerseklet masik) {
		return this.hoertek > masik.hoertek;
	}
	
	
	public static Homerseklet ketHoOsszeg(Homerseklet a, Homerseklet b) {
		return new Homerseklet(a.hoertek + b.hoertek);
	}
	
	
	/* tobb homersekelet ad ossze, tomb! */
	public static Homerseklet osszeg(Homerseklet... hok) {
		double ossz = 0;
		for(Homerseklet h : hok)
			ossz  += h.hoertek;
		return new Homerseklet(ossz);
	}
	
	
	public static double hoerteke(MertekEgyseg egyseg, Homerseklet ho) {
		return ho.getHo(egyseg);
	}
}

/* a tobbi HF */