package gyak6;

public class Homerseklet implements IHasonlithato<Homerseklet> {
	public enum Mertekegyseg {CELSIUS, KELVIN};
	private double hoertek;
	
	public Homerseklet(double ho, Mertekegyseg egyseg) {
		if(egyseg == Mertekegyseg.KELVIN) 
			this.hoertek = ho;
		else
			this.hoertek = celsiusToKelvin(ho);
	}
	
	public Homerseklet(double ho) {
		this(ho,Mertekegyseg.KELVIN);
	}
	
	public double celsiusToKelvin(double ho) {
		return ho + 273.1;
	}
	
	public double kelvinToCelsius(double ho) {
		return ho - 273.1;
	}
	
	public String toString() {
		return this.hoertek + " Kelvin";
	}
	
	public double getHo(Mertekegyseg egyseg) {
		if(egyseg == Mertekegyseg.KELVIN)
			return this.hoertek;
		else
			return kelvinToCelsius(this.hoertek);
	}
	
	public boolean nagyobbE(Homerseklet masik) {
		return masik.hoertek > this.hoertek;
	}
	
	public Homerseklet ketHoOsszeg(Homerseklet a, Homerseklet b) {
		return new Homerseklet(a.hoertek + b.hoertek);
	}
	
	public Homerseklet sokHoOsszeg(Homerseklet... hok) {
		double ossz = 0;
		
		for(Homerseklet h : hok) {
			ossz += h.hoertek;
		}
		return new Homerseklet(ossz);	
	}
	
	public double hoVissza(Homerseklet ho, Mertekegyseg egyseg) {
		return ho.getHo(egyseg);
	}
	
	public int hasonlit(Homerseklet ob) {
		Homerseklet h = (Homerseklet)ob;
		
		if(this.hoertek > h.hoertek)
			return 1;
		if(this.hoertek < h.hoertek)
			return -1;
		return 0;
	}

	

	@Override
	public boolean equals(Object obj) {
		if(obj == null)
			return false;
		if(!(obj instanceof Homerseklet))
			return false;
		Homerseklet h = (Homerseklet)obj;
		
		return this.hoertek == h.hoertek;
	}
	
	
	
}
