package gyak7_feladat14;

public class Konyv implements Comparable<Konyv> {
	private String iro;
	private String cim;
	private int ar;
	
	public Konyv(String iro, String cim, int ar) {
		this.iro = iro;
		this.cim = cim;
		this.ar = ar;
	}
	
	public String toString() {
		return "Iro: " + this.iro + ", Cim: " + this.cim + ", Ar: " + this.ar;
	}

	/* most ez nem kell */
	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((cim == null) ? 0 : cim.hashCode());
		result = PRIME * result + ((iro == null) ? 0 : iro.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())   /* ha osztalyuk nem egyezik */
			return false;
		
		final Konyv other = (Konyv) obj;
		if (cim == null) {
			if (other.cim != null)
				return false;
		} else if (!cim.equals(other.cim)) /* cim egyezik-e */
			return false;
		
		if (iro == null) {
			if (other.iro != null)
				return false;
		} else if (!iro.equals(other.iro)) /* iro egyezik-e */
			return false;
		return true;
	}
	
	
	public int compareTo(Konyv arg) {
		int iroHas = this.iro.compareTo(arg.iro);
		
		if(iroHas == 0)
			return this.cim.compareTo(arg.cim);
		return iroHas;
	}


	public int arHasonlito(Konyv masik) {
		if(this.ar > masik.ar)
			return 1;
		if(this.ar < masik.ar)
			return -1;
		return 0;
	}		
}
