package gyak7_feladat14;

import java.util.*;

public class KonyvesPolc {
	private ArrayList<Konyv> konyvek;
	
	public KonyvesPolc() {
		this.konyvek = new ArrayList<Konyv>();
	}
	
	public Konyv[] konyvekTombben() {
		Konyv[] kt = new Konyv[this.konyvek.size()];
		return this.konyvek.toArray(kt);
	}
	
	public void hozzaad(Konyv uj) {
		this.konyvek.add(uj);
	}
	
	public int konyvekSzama() {
		return this.konyvek.size();
	}
	
	public Konyv keres(String iro, String cim) {
		Konyv k = new Konyv(iro, cim, 0);
		int hol = this.konyvek.indexOf(k);  /* k indext keresi */
		
		if(hol == -1) 
			return null;   					/* nincs ilyen konyv */
		return this.konyvek.get(hol);
	}
	
	public void torles(Konyv k) {
		this.konyvek.remove(k);
	}
	
	public void torles(String iro, String cim) {
		Konyv k = new Konyv(iro, cim,0);
		this.konyvek.remove(k);
	}
	
	public Konyv[] konyvekTombbenRendezve() {
		Konyv[] kt = konyvekTombben();
		Arrays.sort(kt);
		return kt;
	}

	
	/* mashogyan */
	public Konyv[] konyvekTombbenRendezve2() {
		ArrayList<Konyv> masolat = new ArrayList<Konyv>(this.konyvek);
		Collections.sort(masolat);
		Konyv[] kt = new Konyv[masolat.size()];
		return masolat.toArray(kt);
	}
	
	public Konyv legdragabb() {
		if(this.konyvek.isEmpty())     /* ha ures */
			return null;
		
		Konyv max = this.konyvek.get(0);
		for(Konyv k : this.konyvek) {
			if(max.arHasonlito(k) == -1)
				max = k;
		}
		return max;
	}
	
	
	/* mashogyan (nevtelen osztalyos) */
	public Konyv legdragabb2() {
		if(this.konyvek.isEmpty())     /* ha ures */
			return null;
		
		Konyv max = Collections.max(this.konyvek, new Comparator<Konyv>() {
			public int compare(Konyv arg0, Konyv arg1) {
				return arg0.arHasonlito(arg1);
			}
		});
		return max;
	}
		
	
}
