package gyak9;

import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;

public class Szemely implements Comparable<Szemely> {

	private String nev;
	private Date szulDatum;
	
	public Szemely(String nev, Date szulDatum) {
		this.nev = new String(nev);
		this.szulDatum = (Date)szulDatum.clone();
	}

	@Override
	public String toString() {
		DateFormat f = DateFormat.getDateInstance(DateFormat.LONG);
		return "Szemely [nev=" + nev + ", szulDatum=" + f.format(szulDatum) + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((nev == null) ? 0 : nev.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Szemely other = (Szemely) obj;
		if (nev == null) {
			if (other.nev != null)
				return false;
		} else if (!nev.equals(other.nev))
			return false;
		return true;
	}

	@Override
	public int compareTo(Szemely o) {
		return this.nev.compareTo(o.nev);
	}
	
	public int korHasonlito(Szemely masik) {
		return this.szulDatum.compareTo(masik.szulDatum);
	}
	
	public int[] szulDatumReszek() {
		int[] reszek = new int[3];
		Calendar cal = Calendar.getInstance();
		cal.setTime(this.szulDatum);
		reszek[0] = cal.get(Calendar.YEAR); 
		reszek[1] = cal.get(Calendar.MONTH) + 1;
		reszek[2] = cal.get(Calendar.DAY_OF_MONTH);
		return reszek;
	}
	
	public int getKorNapokban() {
		Calendar szul = Calendar.getInstance();
		szul.setTime(this.szulDatum);
		Calendar most = Calendar.getInstance();
		long kul = most.getTimeInMillis() - szul.getTimeInMillis();
		return (int)(kul / (24*3600*1000));
	}
	
	public int szuletesnapNapMulva() {
		Calendar most = Calendar.getInstance();
		Calendar szulnapkovetkezo = Calendar.getInstance();
		szulnapkovetkezo.setTime(this.szulDatum);
		szulnapkovetkezo.set(Calendar.YEAR, most.get(Calendar.YEAR));
		if (szulnapkovetkezo.before(most))
			szulnapkovetkezo.add(Calendar.YEAR, 1);
		long kul = szulnapkovetkezo.getTimeInMillis() - most.getTimeInMillis();
		return (int)(kul / (24*3600*1000));		
	}
}
