package gyak9;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;

public class Szemelyek {
	
	private static final Comparator<Szemely> SZULCOMPARATOR = new Comparator<Szemely>() {

		@Override
		public int compare(Szemely o1, Szemely o2) {
			return o1.korHasonlito(o2);
		}
		
	};

	private ArrayList<Szemely> lista;
	
	public Szemelyek() {
		this.lista = new ArrayList<Szemely>();
	}
	
	public void hozzaad(Szemely s) {
		this.lista.add(s);
	}
	
	public int szemelyekSzama() {
		return this.lista.size();
	}
	
	public void torol(Szemely s) {
		this.lista.remove(s);
	}

	public Szemely keres(String nev) {
		Szemely keresendo = new Szemely(nev, new Date());
		int hol = this.lista.indexOf(keresendo);
		if (hol == -1)
			return null;
		return this.lista.get(hol);
	}
	
	public Szemely[] szemelyekNevSorban() {
		Szemely[] st = new Szemely[this.lista.size()];
		this.lista.toArray(st);
		Arrays.sort(st);
		return st;
	}
	
	public Szemely[] szemelyekSzulSorban() {
		ArrayList<Szemely> masolat = new ArrayList<Szemely>(this.lista);
		Collections.sort(masolat, SZULCOMPARATOR);
		Szemely[] st = new Szemely[masolat.size()];
		return masolat.toArray(st);
	}
	
	public Szemely[] akiknekXNaponBelulLeszASzulNap(int x) {
		ArrayList<Szemely> szulisek = new ArrayList<Szemely>();
		for (Szemely s : this.lista) {
			if (s.szuletesnapNapMulva() < x)
				szulisek.add(s);
		}
		if (szulisek.size() == 0)
			return null;
		Szemely[] st = new Szemely[szulisek.size()];
		return szulisek.toArray(st);
	}
}

